# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Connection do
  @moduledoc """
  Handle Tesla connections for GoogleApi.YouTube.V3.
  """

  @type t :: Tesla.Env.client()

  use GoogleApi.Gax.Connection,
    scopes: [
      # Manage your YouTube account
      "https://www.googleapis.com/auth/youtube",

      # See a list of your current active channel members, their current level, and when they became a member
      "https://www.googleapis.com/auth/youtube.channel-memberships.creator",

      # See, edit, and permanently delete your YouTube videos, ratings, comments and captions
      "https://www.googleapis.com/auth/youtube.force-ssl",

      # View your YouTube account
      "https://www.googleapis.com/auth/youtube.readonly",

      # Manage your YouTube videos
      "https://www.googleapis.com/auth/youtube.upload",

      # View and manage your assets and associated content on YouTube
      "https://www.googleapis.com/auth/youtubepartner",

      # View private information of your YouTube channel relevant during the audit process with a YouTube partner
      "https://www.googleapis.com/auth/youtubepartner-channel-audit"
    ],
    otp_app: :google_api_you_tube,
    base_url: "https://youtube.googleapis.com/"
end
