# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ActivityContentDetailsSocial do
  @moduledoc """
  Details about a social network post.

  ## Attributes

  *   `author` (*type:* `String.t`, *default:* `nil`) - The author of the social network post.
  *   `imageUrl` (*type:* `String.t`, *default:* `nil`) - An image of the post's author.
  *   `referenceUrl` (*type:* `String.t`, *default:* `nil`) - The URL of the social network post.
  *   `resourceId` (*type:* `GoogleApi.YouTube.V3.Model.ResourceId.t`, *default:* `nil`) - The resourceId object encapsulates information that identifies the resource associated with a social network post.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The name of the social network.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :author => String.t() | nil,
          :imageUrl => String.t() | nil,
          :referenceUrl => String.t() | nil,
          :resourceId => GoogleApi.YouTube.V3.Model.ResourceId.t() | nil,
          :type => String.t() | nil
        }

  field(:author)
  field(:imageUrl)
  field(:referenceUrl)
  field(:resourceId, as: GoogleApi.YouTube.V3.Model.ResourceId)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ActivityContentDetailsSocial do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ActivityContentDetailsSocial.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ActivityContentDetailsSocial do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
