# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ActivitySnippet do
  @moduledoc """
  Basic details about an activity, including title, description, thumbnails, activity type and group. Next ID: 12

  ## Attributes

  *   `channelId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the channel associated with the activity.
  *   `channelTitle` (*type:* `String.t`, *default:* `nil`) - Channel title for the channel responsible for this activity
  *   `description` (*type:* `String.t`, *default:* `nil`) - The description of the resource primarily associated with the activity. @mutable youtube.activities.insert
  *   `groupId` (*type:* `String.t`, *default:* `nil`) - The group ID associated with the activity. A group ID identifies user events that are associated with the same user and resource. For example, if a user rates a video and marks the same video as a favorite, the entries for those events would have the same group ID in the user's activity feed. In your user interface, you can avoid repetition by grouping events with the same groupId value.
  *   `publishedAt` (*type:* `DateTime.t`, *default:* `nil`) - The date and time that the video was uploaded.
  *   `thumbnails` (*type:* `GoogleApi.YouTube.V3.Model.ThumbnailDetails.t`, *default:* `nil`) - A map of thumbnail images associated with the resource that is primarily associated with the activity. For each object in the map, the key is the name of the thumbnail image, and the value is an object that contains other information about the thumbnail.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The title of the resource primarily associated with the activity.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of activity that the resource describes.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelId => String.t() | nil,
          :channelTitle => String.t() | nil,
          :description => String.t() | nil,
          :groupId => String.t() | nil,
          :publishedAt => DateTime.t() | nil,
          :thumbnails => GoogleApi.YouTube.V3.Model.ThumbnailDetails.t() | nil,
          :title => String.t() | nil,
          :type => String.t() | nil
        }

  field(:channelId)
  field(:channelTitle)
  field(:description)
  field(:groupId)
  field(:publishedAt, as: DateTime)
  field(:thumbnails, as: GoogleApi.YouTube.V3.Model.ThumbnailDetails)
  field(:title)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ActivitySnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ActivitySnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ActivitySnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
