# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ChannelContentDetailsRelatedPlaylists do
  @moduledoc """


  ## Attributes

  *   `favorites` (*type:* `String.t`, *default:* `nil`) - The ID of the playlist that contains the channel"s favorite videos. Use the playlistItems.insert and playlistItems.delete to add or remove items from that list.
  *   `likes` (*type:* `String.t`, *default:* `nil`) - The ID of the playlist that contains the channel"s liked videos. Use the playlistItems.insert and playlistItems.delete to add or remove items from that list.
  *   `uploads` (*type:* `String.t`, *default:* `nil`) - The ID of the playlist that contains the channel"s uploaded videos. Use the videos.insert method to upload new videos and the videos.delete method to delete previously uploaded videos.
  *   `watchHistory` (*type:* `String.t`, *default:* `nil`) - The ID of the playlist that contains the channel"s watch history. Use the playlistItems.insert and playlistItems.delete to add or remove items from that list.
  *   `watchLater` (*type:* `String.t`, *default:* `nil`) - The ID of the playlist that contains the channel"s watch later playlist. Use the playlistItems.insert and playlistItems.delete to add or remove items from that list.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :favorites => String.t() | nil,
          :likes => String.t() | nil,
          :uploads => String.t() | nil,
          :watchHistory => String.t() | nil,
          :watchLater => String.t() | nil
        }

  field(:favorites)
  field(:likes)
  field(:uploads)
  field(:watchHistory)
  field(:watchLater)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ChannelContentDetailsRelatedPlaylists do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ChannelContentDetailsRelatedPlaylists.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ChannelContentDetailsRelatedPlaylists do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
