# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ChannelSectionTargeting do
  @moduledoc """
  ChannelSection targeting setting.

  ## Attributes

  *   `countries` (*type:* `list(String.t)`, *default:* `nil`) - The country the channel section is targeting.
  *   `languages` (*type:* `list(String.t)`, *default:* `nil`) - The language the channel section is targeting.
  *   `regions` (*type:* `list(String.t)`, *default:* `nil`) - The region the channel section is targeting.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :countries => list(String.t()) | nil,
          :languages => list(String.t()) | nil,
          :regions => list(String.t()) | nil
        }

  field(:countries, type: :list)
  field(:languages, type: :list)
  field(:regions, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ChannelSectionTargeting do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ChannelSectionTargeting.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ChannelSectionTargeting do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
