# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ChannelStatus do
  @moduledoc """
  JSON template for the status part of a channel.

  ## Attributes

  *   `isLinked` (*type:* `boolean()`, *default:* `nil`) - If true, then the user is linked to either a YouTube username or G+ account. Otherwise, the user doesn't have a public YouTube identity.
  *   `longUploadsStatus` (*type:* `String.t`, *default:* `nil`) - The long uploads status of this channel. See https://support.google.com/youtube/answer/71673 for more information.
  *   `madeForKids` (*type:* `boolean()`, *default:* `nil`) - 
  *   `privacyStatus` (*type:* `String.t`, *default:* `nil`) - Privacy status of the channel.
  *   `selfDeclaredMadeForKids` (*type:* `boolean()`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :isLinked => boolean() | nil,
          :longUploadsStatus => String.t() | nil,
          :madeForKids => boolean() | nil,
          :privacyStatus => String.t() | nil,
          :selfDeclaredMadeForKids => boolean() | nil
        }

  field(:isLinked)
  field(:longUploadsStatus)
  field(:madeForKids)
  field(:privacyStatus)
  field(:selfDeclaredMadeForKids)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ChannelStatus do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ChannelStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ChannelStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
