# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.CommentThread do
  @moduledoc """
  A *comment thread* represents information that applies to a top level comment and all its replies. It can also include the top level comment itself and some of the replies.

  ## Attributes

  *   `etag` (*type:* `String.t`, *default:* `nil`) - Etag of this resource.
  *   `id` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the comment thread.
  *   `kind` (*type:* `String.t`, *default:* `youtube#commentThread`) - Identifies what kind of resource this is. Value: the fixed string "youtube#commentThread".
  *   `replies` (*type:* `GoogleApi.YouTube.V3.Model.CommentThreadReplies.t`, *default:* `nil`) - The replies object contains a limited number of replies (if any) to the top level comment found in the snippet.
  *   `snippet` (*type:* `GoogleApi.YouTube.V3.Model.CommentThreadSnippet.t`, *default:* `nil`) - The snippet object contains basic details about the comment thread and also the top level comment.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :etag => String.t() | nil,
          :id => String.t() | nil,
          :kind => String.t() | nil,
          :replies => GoogleApi.YouTube.V3.Model.CommentThreadReplies.t() | nil,
          :snippet => GoogleApi.YouTube.V3.Model.CommentThreadSnippet.t() | nil
        }

  field(:etag)
  field(:id)
  field(:kind)
  field(:replies, as: GoogleApi.YouTube.V3.Model.CommentThreadReplies)
  field(:snippet, as: GoogleApi.YouTube.V3.Model.CommentThreadSnippet)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.CommentThread do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.CommentThread.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.CommentThread do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
