# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.CuepointSchedule do
  @moduledoc """
  Schedule to insert cuepoints into a broadcast by ads automator.

  ## Attributes

  *   `enabled` (*type:* `boolean()`, *default:* `nil`) - This field is semantically required. If it is set false or not set, other fields in this message will be ignored.
  *   `pauseAdsUntil` (*type:* `String.t`, *default:* `nil`) - If set, automatic cuepoint insertion is paused until this timestamp ("No Ad Zone"). The value is specified in ISO 8601 format.
  *   `repeatIntervalSecs` (*type:* `integer()`, *default:* `nil`) - Interval frequency in seconds that api uses to insert cuepoints automatically.
  *   `scheduleStrategy` (*type:* `String.t`, *default:* `nil`) - The strategy to use when scheduling cuepoints.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :enabled => boolean() | nil,
          :pauseAdsUntil => String.t() | nil,
          :repeatIntervalSecs => integer() | nil,
          :scheduleStrategy => String.t() | nil
        }

  field(:enabled)
  field(:pauseAdsUntil)
  field(:repeatIntervalSecs)
  field(:scheduleStrategy)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.CuepointSchedule do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.CuepointSchedule.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.CuepointSchedule do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
