# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.InvideoPosition do
  @moduledoc """
  Describes the spatial position of a visual widget inside a video. It is a union of various position types, out of which only will be set one.

  ## Attributes

  *   `cornerPosition` (*type:* `String.t`, *default:* `nil`) - Describes in which corner of the video the visual widget will appear.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Defines the position type.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cornerPosition => String.t() | nil,
          :type => String.t() | nil
        }

  field(:cornerPosition)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.InvideoPosition do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.InvideoPosition.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.InvideoPosition do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
