# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveChatBanSnippet do
  @moduledoc """


  ## Attributes

  *   `banDurationSeconds` (*type:* `String.t`, *default:* `nil`) - The duration of a ban, only filled if the ban has type TEMPORARY.
  *   `bannedUserDetails` (*type:* `GoogleApi.YouTube.V3.Model.ChannelProfileDetails.t`, *default:* `nil`) - 
  *   `liveChatId` (*type:* `String.t`, *default:* `nil`) - The chat this ban is pertinent to.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of ban.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :banDurationSeconds => String.t() | nil,
          :bannedUserDetails => GoogleApi.YouTube.V3.Model.ChannelProfileDetails.t() | nil,
          :liveChatId => String.t() | nil,
          :type => String.t() | nil
        }

  field(:banDurationSeconds)
  field(:bannedUserDetails, as: GoogleApi.YouTube.V3.Model.ChannelProfileDetails)
  field(:liveChatId)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveChatBanSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveChatBanSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveChatBanSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
