# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveChatMessage do
  @moduledoc """
  A *liveChatMessage* resource represents a chat message in a YouTube Live Chat.

  ## Attributes

  *   `authorDetails` (*type:* `GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails.t`, *default:* `nil`) - The authorDetails object contains basic details about the user that posted this message.
  *   `etag` (*type:* `String.t`, *default:* `nil`) - Etag of this resource.
  *   `id` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube assigns to uniquely identify the message.
  *   `kind` (*type:* `String.t`, *default:* `youtube#liveChatMessage`) - Identifies what kind of resource this is. Value: the fixed string "youtube#liveChatMessage".
  *   `snippet` (*type:* `GoogleApi.YouTube.V3.Model.LiveChatMessageSnippet.t`, *default:* `nil`) - The snippet object contains basic details about the message.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :authorDetails => GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails.t() | nil,
          :etag => String.t() | nil,
          :id => String.t() | nil,
          :kind => String.t() | nil,
          :snippet => GoogleApi.YouTube.V3.Model.LiveChatMessageSnippet.t() | nil
        }

  field(:authorDetails, as: GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails)
  field(:etag)
  field(:id)
  field(:kind)
  field(:snippet, as: GoogleApi.YouTube.V3.Model.LiveChatMessageSnippet)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveChatMessage do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveChatMessage.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveChatMessage do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
