# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails do
  @moduledoc """


  ## Attributes

  *   `channelId` (*type:* `String.t`, *default:* `nil`) - The YouTube channel ID.
  *   `channelUrl` (*type:* `String.t`, *default:* `nil`) - The channel's URL.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - The channel's display name.
  *   `isChatModerator` (*type:* `boolean()`, *default:* `nil`) - Whether the author is a moderator of the live chat.
  *   `isChatOwner` (*type:* `boolean()`, *default:* `nil`) - Whether the author is the owner of the live chat.
  *   `isChatSponsor` (*type:* `boolean()`, *default:* `nil`) - Whether the author is a sponsor of the live chat.
  *   `isVerified` (*type:* `boolean()`, *default:* `nil`) - Whether the author's identity has been verified by YouTube.
  *   `profileImageUrl` (*type:* `String.t`, *default:* `nil`) - The channels's avatar URL.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelId => String.t() | nil,
          :channelUrl => String.t() | nil,
          :displayName => String.t() | nil,
          :isChatModerator => boolean() | nil,
          :isChatOwner => boolean() | nil,
          :isChatSponsor => boolean() | nil,
          :isVerified => boolean() | nil,
          :profileImageUrl => String.t() | nil
        }

  field(:channelId)
  field(:channelUrl)
  field(:displayName)
  field(:isChatModerator)
  field(:isChatOwner)
  field(:isChatSponsor)
  field(:isVerified)
  field(:profileImageUrl)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveChatMessageAuthorDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
