# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveChatSuperStickerDetails do
  @moduledoc """


  ## Attributes

  *   `amountDisplayString` (*type:* `String.t`, *default:* `nil`) - A rendered string that displays the fund amount and currency to the user.
  *   `amountMicros` (*type:* `String.t`, *default:* `nil`) - The amount purchased by the user, in micros (1,750,000 micros = 1.75).
  *   `currency` (*type:* `String.t`, *default:* `nil`) - The currency in which the purchase was made.
  *   `superStickerMetadata` (*type:* `GoogleApi.YouTube.V3.Model.SuperStickerMetadata.t`, *default:* `nil`) - Information about the Super Sticker.
  *   `tier` (*type:* `integer()`, *default:* `nil`) - The tier in which the amount belongs. Lower amounts belong to lower tiers. The lowest tier is 1.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :amountDisplayString => String.t() | nil,
          :amountMicros => String.t() | nil,
          :currency => String.t() | nil,
          :superStickerMetadata => GoogleApi.YouTube.V3.Model.SuperStickerMetadata.t() | nil,
          :tier => integer() | nil
        }

  field(:amountDisplayString)
  field(:amountMicros)
  field(:currency)
  field(:superStickerMetadata, as: GoogleApi.YouTube.V3.Model.SuperStickerMetadata)
  field(:tier)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveChatSuperStickerDetails do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveChatSuperStickerDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveChatSuperStickerDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
