# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveStream do
  @moduledoc """
  A live stream describes a live ingestion point.

  ## Attributes

  *   `cdn` (*type:* `GoogleApi.YouTube.V3.Model.CdnSettings.t`, *default:* `nil`) - The cdn object defines the live stream's content delivery network (CDN) settings. These settings provide details about the manner in which you stream your content to YouTube.
  *   `contentDetails` (*type:* `GoogleApi.YouTube.V3.Model.LiveStreamContentDetails.t`, *default:* `nil`) - The content_details object contains information about the stream, including the closed captions ingestion URL.
  *   `etag` (*type:* `String.t`, *default:* `nil`) - Etag of this resource.
  *   `id` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube assigns to uniquely identify the stream.
  *   `kind` (*type:* `String.t`, *default:* `youtube#liveStream`) - Identifies what kind of resource this is. Value: the fixed string "youtube#liveStream".
  *   `snippet` (*type:* `GoogleApi.YouTube.V3.Model.LiveStreamSnippet.t`, *default:* `nil`) - The snippet object contains basic details about the stream, including its channel, title, and description.
  *   `status` (*type:* `GoogleApi.YouTube.V3.Model.LiveStreamStatus.t`, *default:* `nil`) - The status object contains information about live stream's status.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cdn => GoogleApi.YouTube.V3.Model.CdnSettings.t() | nil,
          :contentDetails => GoogleApi.YouTube.V3.Model.LiveStreamContentDetails.t() | nil,
          :etag => String.t() | nil,
          :id => String.t() | nil,
          :kind => String.t() | nil,
          :snippet => GoogleApi.YouTube.V3.Model.LiveStreamSnippet.t() | nil,
          :status => GoogleApi.YouTube.V3.Model.LiveStreamStatus.t() | nil
        }

  field(:cdn, as: GoogleApi.YouTube.V3.Model.CdnSettings)
  field(:contentDetails, as: GoogleApi.YouTube.V3.Model.LiveStreamContentDetails)
  field(:etag)
  field(:id)
  field(:kind)
  field(:snippet, as: GoogleApi.YouTube.V3.Model.LiveStreamSnippet)
  field(:status, as: GoogleApi.YouTube.V3.Model.LiveStreamStatus)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveStream do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveStream.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveStream do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
