# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LiveStreamSnippet do
  @moduledoc """


  ## Attributes

  *   `channelId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the channel that is transmitting the stream.
  *   `description` (*type:* `String.t`, *default:* `nil`) - The stream's description. The value cannot be longer than 10000 characters.
  *   `isDefaultStream` (*type:* `boolean()`, *default:* `nil`) - 
  *   `publishedAt` (*type:* `DateTime.t`, *default:* `nil`) - The date and time that the stream was created.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The stream's title. The value must be between 1 and 128 characters long.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelId => String.t() | nil,
          :description => String.t() | nil,
          :isDefaultStream => boolean() | nil,
          :publishedAt => DateTime.t() | nil,
          :title => String.t() | nil
        }

  field(:channelId)
  field(:description)
  field(:isDefaultStream)
  field(:publishedAt, as: DateTime)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LiveStreamSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LiveStreamSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LiveStreamSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
