# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.LocalizedProperty do
  @moduledoc """


  ## Attributes

  *   `default` (*type:* `String.t`, *default:* `nil`) - 
  *   `defaultLanguage` (*type:* `GoogleApi.YouTube.V3.Model.LanguageTag.t`, *default:* `nil`) - The language of the default property.
  *   `localized` (*type:* `list(GoogleApi.YouTube.V3.Model.LocalizedString.t)`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :default => String.t() | nil,
          :defaultLanguage => GoogleApi.YouTube.V3.Model.LanguageTag.t() | nil,
          :localized => list(GoogleApi.YouTube.V3.Model.LocalizedString.t()) | nil
        }

  field(:default)
  field(:defaultLanguage, as: GoogleApi.YouTube.V3.Model.LanguageTag)
  field(:localized, as: GoogleApi.YouTube.V3.Model.LocalizedString, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.LocalizedProperty do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.LocalizedProperty.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.LocalizedProperty do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
