# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.MemberSnippet do
  @moduledoc """


  ## Attributes

  *   `creatorChannelId` (*type:* `String.t`, *default:* `nil`) - The id of the channel that's offering memberships.
  *   `memberDetails` (*type:* `GoogleApi.YouTube.V3.Model.ChannelProfileDetails.t`, *default:* `nil`) - Details about the member.
  *   `membershipsDetails` (*type:* `GoogleApi.YouTube.V3.Model.MembershipsDetails.t`, *default:* `nil`) - Details about the user's membership.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :creatorChannelId => String.t() | nil,
          :memberDetails => GoogleApi.YouTube.V3.Model.ChannelProfileDetails.t() | nil,
          :membershipsDetails => GoogleApi.YouTube.V3.Model.MembershipsDetails.t() | nil
        }

  field(:creatorChannelId)
  field(:memberDetails, as: GoogleApi.YouTube.V3.Model.ChannelProfileDetails)
  field(:membershipsDetails, as: GoogleApi.YouTube.V3.Model.MembershipsDetails)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.MemberSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.MemberSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.MemberSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
