# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.PageInfo do
  @moduledoc """
  Paging details for lists of resources, including total number of items available and number of resources returned in a single page.

  ## Attributes

  *   `resultsPerPage` (*type:* `integer()`, *default:* `nil`) - The number of results included in the API response.
  *   `totalResults` (*type:* `integer()`, *default:* `nil`) - The total number of results in the result set.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resultsPerPage => integer() | nil,
          :totalResults => integer() | nil
        }

  field(:resultsPerPage)
  field(:totalResults)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.PageInfo do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.PageInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.PageInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
