# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.PlaylistItemSnippet do
  @moduledoc """
  Basic details about a playlist, including title, description and thumbnails. Basic details of a YouTube Playlist item provided by the author. Next ID: 15

  ## Attributes

  *   `channelId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the user that added the item to the playlist.
  *   `channelTitle` (*type:* `String.t`, *default:* `nil`) - Channel title for the channel that the playlist item belongs to.
  *   `description` (*type:* `String.t`, *default:* `nil`) - The item's description.
  *   `playlistId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify thGe playlist that the playlist item is in.
  *   `position` (*type:* `integer()`, *default:* `nil`) - The order in which the item appears in the playlist. The value uses a zero-based index, so the first item has a position of 0, the second item has a position of 1, and so forth.
  *   `publishedAt` (*type:* `DateTime.t`, *default:* `nil`) - The date and time that the item was added to the playlist.
  *   `resourceId` (*type:* `GoogleApi.YouTube.V3.Model.ResourceId.t`, *default:* `nil`) - The id object contains information that can be used to uniquely identify the resource that is included in the playlist as the playlist item.
  *   `thumbnails` (*type:* `GoogleApi.YouTube.V3.Model.ThumbnailDetails.t`, *default:* `nil`) - A map of thumbnail images associated with the playlist item. For each object in the map, the key is the name of the thumbnail image, and the value is an object that contains other information about the thumbnail.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The item's title.
  *   `videoOwnerChannelId` (*type:* `String.t`, *default:* `nil`) - Channel id for the channel this video belongs to.
  *   `videoOwnerChannelTitle` (*type:* `String.t`, *default:* `nil`) - Channel title for the channel this video belongs to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelId => String.t() | nil,
          :channelTitle => String.t() | nil,
          :description => String.t() | nil,
          :playlistId => String.t() | nil,
          :position => integer() | nil,
          :publishedAt => DateTime.t() | nil,
          :resourceId => GoogleApi.YouTube.V3.Model.ResourceId.t() | nil,
          :thumbnails => GoogleApi.YouTube.V3.Model.ThumbnailDetails.t() | nil,
          :title => String.t() | nil,
          :videoOwnerChannelId => String.t() | nil,
          :videoOwnerChannelTitle => String.t() | nil
        }

  field(:channelId)
  field(:channelTitle)
  field(:description)
  field(:playlistId)
  field(:position)
  field(:publishedAt, as: DateTime)
  field(:resourceId, as: GoogleApi.YouTube.V3.Model.ResourceId)
  field(:thumbnails, as: GoogleApi.YouTube.V3.Model.ThumbnailDetails)
  field(:title)
  field(:videoOwnerChannelId)
  field(:videoOwnerChannelTitle)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.PlaylistItemSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.PlaylistItemSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.PlaylistItemSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
