# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.SubscriptionContentDetails do
  @moduledoc """
  Details about the content to witch a subscription refers.

  ## Attributes

  *   `activityType` (*type:* `String.t`, *default:* `nil`) - The type of activity this subscription is for (only uploads, everything).
  *   `newItemCount` (*type:* `integer()`, *default:* `nil`) - The number of new items in the subscription since its content was last read.
  *   `totalItemCount` (*type:* `integer()`, *default:* `nil`) - The approximate number of items that the subscription points to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :activityType => String.t() | nil,
          :newItemCount => integer() | nil,
          :totalItemCount => integer() | nil
        }

  field(:activityType)
  field(:newItemCount)
  field(:totalItemCount)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.SubscriptionContentDetails do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.SubscriptionContentDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.SubscriptionContentDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
