# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.SubscriptionSnippet do
  @moduledoc """
  Basic details about a subscription, including title, description and thumbnails of the subscribed item.

  ## Attributes

  *   `channelId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the subscriber's channel.
  *   `channelTitle` (*type:* `String.t`, *default:* `nil`) - Channel title for the channel that the subscription belongs to.
  *   `description` (*type:* `String.t`, *default:* `nil`) - The subscription's details.
  *   `publishedAt` (*type:* `DateTime.t`, *default:* `nil`) - The date and time that the subscription was created.
  *   `resourceId` (*type:* `GoogleApi.YouTube.V3.Model.ResourceId.t`, *default:* `nil`) - The id object contains information about the channel that the user subscribed to.
  *   `thumbnails` (*type:* `GoogleApi.YouTube.V3.Model.ThumbnailDetails.t`, *default:* `nil`) - A map of thumbnail images associated with the video. For each object in the map, the key is the name of the thumbnail image, and the value is an object that contains other information about the thumbnail.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The subscription's title.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelId => String.t() | nil,
          :channelTitle => String.t() | nil,
          :description => String.t() | nil,
          :publishedAt => DateTime.t() | nil,
          :resourceId => GoogleApi.YouTube.V3.Model.ResourceId.t() | nil,
          :thumbnails => GoogleApi.YouTube.V3.Model.ThumbnailDetails.t() | nil,
          :title => String.t() | nil
        }

  field(:channelId)
  field(:channelTitle)
  field(:description)
  field(:publishedAt, as: DateTime)
  field(:resourceId, as: GoogleApi.YouTube.V3.Model.ResourceId)
  field(:thumbnails, as: GoogleApi.YouTube.V3.Model.ThumbnailDetails)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.SubscriptionSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.SubscriptionSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.SubscriptionSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
