# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ThirdPartyLink do
  @moduledoc """
  A *third party account link* resource represents a link between a YouTube account or a channel and an account on a third-party service.

  ## Attributes

  *   `etag` (*type:* `String.t`, *default:* `nil`) - Etag of this resource
  *   `kind` (*type:* `String.t`, *default:* `youtube#thirdPartyLink`) - Identifies what kind of resource this is. Value: the fixed string "youtube#thirdPartyLink".
  *   `linkingToken` (*type:* `String.t`, *default:* `nil`) - The linking_token identifies a YouTube account and channel with which the third party account is linked.
  *   `snippet` (*type:* `GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet.t`, *default:* `nil`) - The snippet object contains basic details about the third- party account link.
  *   `status` (*type:* `GoogleApi.YouTube.V3.Model.ThirdPartyLinkStatus.t`, *default:* `nil`) - The status object contains information about the status of the link.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :etag => String.t() | nil,
          :kind => String.t() | nil,
          :linkingToken => String.t() | nil,
          :snippet => GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet.t() | nil,
          :status => GoogleApi.YouTube.V3.Model.ThirdPartyLinkStatus.t() | nil
        }

  field(:etag)
  field(:kind)
  field(:linkingToken)
  field(:snippet, as: GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet)
  field(:status, as: GoogleApi.YouTube.V3.Model.ThirdPartyLinkStatus)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ThirdPartyLink do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ThirdPartyLink.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ThirdPartyLink do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
