# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet do
  @moduledoc """
  Basic information about a third party account link, including its type and type-specific information.

  ## Attributes

  *   `channelToStoreLink` (*type:* `GoogleApi.YouTube.V3.Model.ChannelToStoreLinkDetails.t`, *default:* `nil`) - Information specific to a link between a channel and a store on a merchandising platform.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of the link named after the entities that are being linked.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :channelToStoreLink => GoogleApi.YouTube.V3.Model.ChannelToStoreLinkDetails.t() | nil,
          :type => String.t() | nil
        }

  field(:channelToStoreLink, as: GoogleApi.YouTube.V3.Model.ChannelToStoreLinkDetails)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ThirdPartyLinkSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
