# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.ThumbnailDetails do
  @moduledoc """
  Internal representation of thumbnails for a YouTube resource.

  ## Attributes

  *   `default` (*type:* `GoogleApi.YouTube.V3.Model.Thumbnail.t`, *default:* `nil`) - The default image for this resource.
  *   `high` (*type:* `GoogleApi.YouTube.V3.Model.Thumbnail.t`, *default:* `nil`) - The high quality image for this resource.
  *   `maxres` (*type:* `GoogleApi.YouTube.V3.Model.Thumbnail.t`, *default:* `nil`) - The maximum resolution quality image for this resource.
  *   `medium` (*type:* `GoogleApi.YouTube.V3.Model.Thumbnail.t`, *default:* `nil`) - The medium quality image for this resource.
  *   `standard` (*type:* `GoogleApi.YouTube.V3.Model.Thumbnail.t`, *default:* `nil`) - The standard quality image for this resource.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :default => GoogleApi.YouTube.V3.Model.Thumbnail.t() | nil,
          :high => GoogleApi.YouTube.V3.Model.Thumbnail.t() | nil,
          :maxres => GoogleApi.YouTube.V3.Model.Thumbnail.t() | nil,
          :medium => GoogleApi.YouTube.V3.Model.Thumbnail.t() | nil,
          :standard => GoogleApi.YouTube.V3.Model.Thumbnail.t() | nil
        }

  field(:default, as: GoogleApi.YouTube.V3.Model.Thumbnail)
  field(:high, as: GoogleApi.YouTube.V3.Model.Thumbnail)
  field(:maxres, as: GoogleApi.YouTube.V3.Model.Thumbnail)
  field(:medium, as: GoogleApi.YouTube.V3.Model.Thumbnail)
  field(:standard, as: GoogleApi.YouTube.V3.Model.Thumbnail)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.ThumbnailDetails do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.ThumbnailDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.ThumbnailDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
