# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.VideoAbuseReport do
  @moduledoc """


  ## Attributes

  *   `comments` (*type:* `String.t`, *default:* `nil`) - Additional comments regarding the abuse report.
  *   `language` (*type:* `String.t`, *default:* `nil`) - The language that the content was viewed in.
  *   `reasonId` (*type:* `String.t`, *default:* `nil`) - The high-level, or primary, reason that the content is abusive. The value is an abuse report reason ID.
  *   `secondaryReasonId` (*type:* `String.t`, *default:* `nil`) - The specific, or secondary, reason that this content is abusive (if available). The value is an abuse report reason ID that is a valid secondary reason for the primary reason.
  *   `videoId` (*type:* `String.t`, *default:* `nil`) - The ID that YouTube uses to uniquely identify the video.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :comments => String.t() | nil,
          :language => String.t() | nil,
          :reasonId => String.t() | nil,
          :secondaryReasonId => String.t() | nil,
          :videoId => String.t() | nil
        }

  field(:comments)
  field(:language)
  field(:reasonId)
  field(:secondaryReasonId)
  field(:videoId)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.VideoAbuseReport do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.VideoAbuseReport.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.VideoAbuseReport do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
