# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.VideoAbuseReportReasonSnippet do
  @moduledoc """
  Basic details about a video category, such as its localized title.

  ## Attributes

  *   `label` (*type:* `String.t`, *default:* `nil`) - The localized label belonging to this abuse report reason.
  *   `secondaryReasons` (*type:* `list(GoogleApi.YouTube.V3.Model.VideoAbuseReportSecondaryReason.t)`, *default:* `nil`) - The secondary reasons associated with this reason, if any are available. (There might be 0 or more.)
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :label => String.t() | nil,
          :secondaryReasons =>
            list(GoogleApi.YouTube.V3.Model.VideoAbuseReportSecondaryReason.t()) | nil
        }

  field(:label)

  field(:secondaryReasons,
    as: GoogleApi.YouTube.V3.Model.VideoAbuseReportSecondaryReason,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.VideoAbuseReportReasonSnippet do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.VideoAbuseReportReasonSnippet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.VideoAbuseReportReasonSnippet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
