# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.VideoAgeGating do
  @moduledoc """


  ## Attributes

  *   `alcoholContent` (*type:* `boolean()`, *default:* `nil`) - Indicates whether or not the video has alcoholic beverage content. Only users of legal purchasing age in a particular country, as identified by ICAP, can view the content.
  *   `restricted` (*type:* `boolean()`, *default:* `nil`) - Age-restricted trailers. For redband trailers and adult-rated video-games. Only users aged 18+ can view the content. The the field is true the content is restricted to viewers aged 18+. Otherwise The field won't be present.
  *   `videoGameRating` (*type:* `String.t`, *default:* `nil`) - Video game rating, if any.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :alcoholContent => boolean() | nil,
          :restricted => boolean() | nil,
          :videoGameRating => String.t() | nil
        }

  field(:alcoholContent)
  field(:restricted)
  field(:videoGameRating)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.VideoAgeGating do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.VideoAgeGating.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.VideoAgeGating do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
