# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.VideoContentDetailsRegionRestriction do
  @moduledoc """
  DEPRECATED Region restriction of the video.

  ## Attributes

  *   `allowed` (*type:* `list(String.t)`, *default:* `nil`) - A list of region codes that identify countries where the video is viewable. If this property is present and a country is not listed in its value, then the video is blocked from appearing in that country. If this property is present and contains an empty list, the video is blocked in all countries.
  *   `blocked` (*type:* `list(String.t)`, *default:* `nil`) - A list of region codes that identify countries where the video is blocked. If this property is present and a country is not listed in its value, then the video is viewable in that country. If this property is present and contains an empty list, the video is viewable in all countries.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :allowed => list(String.t()) | nil,
          :blocked => list(String.t()) | nil
        }

  field(:allowed, type: :list)
  field(:blocked, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.VideoContentDetailsRegionRestriction do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.VideoContentDetailsRegionRestriction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.VideoContentDetailsRegionRestriction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
