# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.YouTube.V3.Model.VideoPlayer do
  @moduledoc """
  Player to be used for a video playback.

  ## Attributes

  *   `embedHeight` (*type:* `String.t`, *default:* `nil`) - 
  *   `embedHtml` (*type:* `String.t`, *default:* `nil`) - An <iframe> tag that embeds a player that will play the video.
  *   `embedWidth` (*type:* `String.t`, *default:* `nil`) - The embed width
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :embedHeight => String.t() | nil,
          :embedHtml => String.t() | nil,
          :embedWidth => String.t() | nil
        }

  field(:embedHeight)
  field(:embedHtml)
  field(:embedWidth)
end

defimpl Poison.Decoder, for: GoogleApi.YouTube.V3.Model.VideoPlayer do
  def decode(value, options) do
    GoogleApi.YouTube.V3.Model.VideoPlayer.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.YouTube.V3.Model.VideoPlayer do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
